BarProfiler = LibStub("AceAddon-3.0"):NewAddon("BarProfiler", "AceConsole-3.0")
BarProfilerGui = LibStub("AceGUI-3.0")
BarProfiler:RegisterChatCommand("barprofiler", "BarProfilerSlash")
function BarProfiler:OnInitialize()	--No support for allready saved db or upgradeing
	BarProfilerDebug = 0
	BarProfilerDebugPrint("Initial function start")
	local Slot = 1
	if BarProfilerDb == nil then
		BarProfilerDebugPrint("No Saved Variables Found")
		BarProfilerDb = {	
						Version = 0.1,
						Realms = {},
						RealmList = {}
						}
		BarProfilerDb.CurrentRealm = GetRealmName()
		BarProfilerDb.CurrentCharacter = GetUnitName("player", True)
		BarProfilerDebugPrint("Db initialised, Call to Realm")
		BarProfilerNewRealm()
		BarProfilerDebugPrint("Call for New Character")
		BarProfilerNewCharacter()
		BarProfilerDebugPrint("Db intialised")
	elseif BarProfilerDb.Version == 0.1 then
		BarProfilerDb.CurrentRealm = GetRealmName()
		BarProfilerDb.CurrentCharacter = GetUnitName("player", True)
		BarProfilerDebugPrint ("Same version found")
		BarProfilerDebugPrint ("Saved Variables Loaded Succesfully")
		if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm] == nil then
			BarProfilerDebugPrint("Call to Realm")
			BarProfilerNewRealm()
			BarProfilerDebugPrint("Call for New Character")
			BarProfilerNewCharacter()
			BarProfilerDebugPrint("Db intialised")
		else
			if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter] == nil then
				BarProfilerDebugPrint("Call for New Character")
				BarProfilerNewCharacter()
				BarProfilerDebugPrint("Db intialised")
			end
		end
	end
	BarProfilerSlashCount = 0
	BarProfilerDebugPrint("Initial function Done")
	BarProfiler:Print ("Loaded")
	tinsert(UISpecialFrames,"BarProfilerMainFrame")
	tinsert(UISpecialFrames,"BarProfilerMessageFrame")
end
function BarProfilerNewRealm()
	BarProfilerDebugPrint ("New Realm function start")
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm] = 	{
														CharacterList = {},
														Characters = {}
														}
	table.insert (BarProfilerDb.RealmList, BarProfilerDb.CurrentRealm)
	BarProfilerDebugPrint ("New Realm function Done")
end
function BarProfilerNewCharacter()
	BarProfilerDebugPrint ("New Character function start")
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter] = 	{
																									ProfileList = {},
																									Profiles = {}
																									}
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Class = UnitClass("player")
	table.insert (BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].CharacterList, BarProfilerDb.CurrentCharacter)
	BarProfilerDebugPrint ("New Character function Done")
end
function BarProfiler:BarProfilerSlash(input)
	BarProfilerDebugPrint("Slash function Start")
	if BarProfilerSlashCount == 0 then
		BarProfilerSlashCount = 1
		BarProfilerDebugPrint("Call to Gui Main")
		BarProfilerGuiMain()
	else
		BarProfilerSlashCount = 0
		BarProfilerGui:Release(BarProfilerMainFrame)
	end
	BarProfilerDebugPrint("Slash function Done")
end
function BarProfilerDebugPrint(Str)
	if BarProfilerDebug == 1 then
		BarProfiler:Print ("DEBUG:",Str)
	end
end
